package com.gmei.up.utils

import scala.concurrent.Future
import com.redis.{ RedisClient, RedisClientPool }

object Redis {
  // TODO read from config file

  implicit val ec: scala.concurrent.ExecutionContext = scala.concurrent.ExecutionContext.global

  val pRc2 = new RedisClient("172.16.40.173", 6379, 0, Some("ReDis!GmTx*0aN9"), 5000)

  // def get_user_portrait_tag3_read_v2(device_id: str, content_type: str) -> Tuple[List[Any], List[Any]]:
  //   key = get_user_portrait_tag3_read_key_v2(device_id, content_type)
  //   date_list_dict = await redis_client2.hgetall(key)
  //   read_list_v2 = []
  //   today_read = []
  //   if date_list_dict:
  //       before_5_days_date = get_before_5_days_date()
  //       today_read = json.loads(date_list_dict.get(before_5_days_date[0].encode(), '[]'))
  //       # 删除5天以外的已读记录
  //       for day in date_list_dict:
  //           day_decode = day.decode()
  //           if day_decode in before_5_days_date:
  //               read_list_v2.extend(json.loads(date_list_dict[day]))
  //           else:
  //               await redis_client2.hdel(key, day)
  //   res = (read_list_v2, today_read)
  //   return res

  val pRc4 =
    new RedisClientPool("172.16.50.145", 6379, database = 0, secret = Some("XfkMCCdWDIU%ls$h"), timeout = 500)

  def getRead(deviceId: String, contentType: String): Unit = {
    val key = s"doris:user_portrait:tag3:read_v2:device_id:${deviceId}:content_type:${contentType}"
    val today = java.time.LocalDate.now.toString()
    val res = pRc2.hget(key, today)
    println(res)
  }

  def save(contentF: Future[IndexedSeq[Content]], deviceId: String, contentType: String): Unit = {
    val key = s"streaming:candidate:${contentType}:device_id:${deviceId}"

    pRc4.withClient { client =>
      contentF.foreach { seq =>
        val ids = seq.map(c => c.id)
        if (ids.size > 0) {
          client.del(key)
          ids.foreach { id =>
            // println(id)
            client.rpush(key, id)
          }
          client.expire(key, 60 * 60 * 24 * 15)
        }
      }
    }
  }
}
